var _crypto = require('crypto'),
	_fs = require('fs');

function md5(str) {
	var _md5 = _crypto.createHash('md5');
	return _md5.update(str).digest('hex');
}

function file_md5(filename, callback) {
	var _md5 = _crypto.createHash('md5');
	var fileStream = _fs.createReadStream(filename);
	fileStream.on('error', function (err) {
		return callback(err, null)
	});
	fileStream.on('data', function (chunk) {
		try {
			_md5.update(chunk)
		} catch (ex) {
			return callback(ex, null)
		}
	});
	fileStream.on('end', function () {
		return callback(null, _md5.digest('hex'))
	});
}

function file_md5_sync(filename) {
	var _md5 = _crypto.createHash('md5');
	var fd = _fs.openSync(filename, 'r');
	var bSize = 1024;
	var length = 0;
	var buffer;
	if (Buffer.from) buffer = Buffer.from(bSize);
	else buffer = new Buffer(bSize);

	for (var b=0; true ;b++) {
		var chunk = _fs.readSync(fd, buffer, 0, bSize, b*bSize);
		_md5.update(buffer.slice(0, chunk));
		if (!chunk || chunk < bSize) break;
	}

	return _md5.digest('hex');
}

module.exports = md5;
module.exports.hex = md5;
module.exports.file = file_md5;
module.exports.fileSync = file_md5_sync;